function anak=CrossOver(probCO, individu, jenisCO)

% Deskripsi : untuk melakukan cross over
% Input : probCO = probabilitas CO
%         individu = sekumpulan individu dalam populasi
%         jenisCO  = jenis operasi cross over yang dipakai
%                    (0 = tukar langsung,
%                     1 = aritmatik)
% Output : anak = anak yang dihasilkan dari proses cross over
%
% 2006 (c) Machine Learning Team
% Politeknik Elektronika Negeri Surabaya - ITS
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

induk=individu;
jumlahinduk=size(induk,1);
jumlahgen=size(induk,2);
anak=induk;
nCO=floor(jumlahinduk/2);
for i=1:nCO
    p=rand;
    if (p<probCO)
        k1=floor(jumlahgen*rand)+1;
        k2=floor((jumlahgen-k1)*rand)+k1;
        if (jenisCO==0)
            for k=k1:k2
                anak(2*i-1,k)=induk(2*i,k);
                anak(2*i,k)=induk(2*i-1,k);
            end
        elseif (jenisCO==1)
            r=0.5*rand;
            for k=k1:k2
                anak(2*i-1,k)=r*induk(2*i-1,k)+(1-r)*induk(2*i,k);
                anak(2*i,k)=(1-r)*induk(2*i-1,k)+r*induk(2*i,k);
            end
        end
    end
end
