%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% Function name : Draw2D
% Description : to draw 2 dimentional data of clustering result
%
% Input : - data -> clustering data
%         - centroids -> centroid of clusters
%         - clusters -> clustering result
% Output : none
%
% Example : Draw2D(data,centroids)
%
% 2006 (C) Ali Ridho Barakbah (ridho@eepis-its.edu)
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


function Draw2D(data,centroids,clusters)

cla
x=data(:,1);
y=data(:,2);

maxx=max(x)+10;
maxy=max(y)+10;

axis([0 maxx 0 maxy])
hold on

plot(x,y,'.');

if (nargin>1)
    for i=1:size(centroids,1)
        tx=centroids(i,1);
        ty=centroids(i,2);
        plot(tx,ty,'r.');
    end
end

if (nargin>2)
    for k=1:size(data,1)
        switch(clusters(k))
            case 1
                plot(x(k),y(k),'y.');
            case 2
                plot(x(k),y(k),'g.');
            case 3
                plot(x(k),y(k),'b.');
            case 4
                plot(x(k),y(k),'m.');
            case 5
                plot(x(k),y(k),'c.');
            case 6
                plot(x(k),y(k),'.','MarkerEdgeColor',[.7 .3 .4]);
            case 7
                plot(x(k),y(k),'.','MarkerEdgeColor',[.5 .9 .4]);
            case 8
                plot(x(k),y(k),'.','MarkerEdgeColor',[.9 .7 .2]);
            case 9
                plot(x(k),y(k),'.','MarkerEdgeColor',[.9 .1 .7]);
            case 10
                plot(x(k),y(k),'.','MarkerEdgeColor',[.5 .4 .2]);
            otherwise
                plot(x(k),y(k),'k.');
        end
    end    
end

hold off

