%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% Function name : Fitness_Centroids
% Input : - individu -> individu dalam populasi
%         - data -> data yang dipakai
% Output : J -> objective function J yang terbalik
% 
% Description : Untuk mendapatkan nilai fitness dengan melakukan
%               pembalikan nilai fungsi tujuan J
%
% 2006 (C) Ali Ridho Barakbah (ridho@eepis-its.edu)
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

function fitness=Fitness_Centroids(individu,data,totalcluster,dimensi)
jumlahindividu=size(individu,1);
fitness=zeros(jumlahindividu,1);
for id=1:jumlahindividu
    centroid=reshape(individu(id,:),totalcluster,dimensi);
    fitness(id)=1/getJ(data, centroid);
end
