% Contoh program kasus optimasi titik pusat K-means
%
% 2006 (c) Ali Ridho Barakbah
% Politeknik Elektronika Negeri Surabaya - ITS
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

clear; clc;

[data,totalcluster]=initLocalRandomPoints(5,10);

dimensi=size(data,2);
totaldata=size(data,1);

jumlahkromosom=totalcluster;
jumlahgenperkromosom=dimensi;
jumlahgen=jumlahgenperkromosom*jumlahkromosom;
jumlahindividu=10;

%Mencari nilai min dan max pada setiap gen
minval=[]; maxval=[];
for i=1:jumlahgen
    pos=mod(i,dimensi);
    if (pos==0) pos=dimensi; end
    minval(i)=min(data(:,pos));
    maxval(i)=max(data(:,pos));
end

% Populasi awal
individu=zeros(jumlahindividu, jumlahgen);
centroid=zeros(totalcluster,dimensi);

for id=1:jumlahindividu
    for i=1:totalcluster
        for j=1:dimensi
            centroid(i,j)=rand*(maxval(j)-minval(j))+minval(j);
        end
    end
    individu(id,:)=reshape(centroid,1,totalcluster*dimensi);
end

[clusters,endcentroid]=KmeansClustering(data,totalcluster,centroid);
Draw2D(data,endcentroid,clusters);
pause

Draw2D(data,centroid);
minJ=getJ(data, centroid)
pause

jumlahgenerasi=100
for i=1:jumlahgenerasi
    %Hitung nilai fitness
    fitness=Fitness_Centroids(individu,data,totalcluster,dimensi);

    % Seleksi dengan roulette
    individu=Selection(individu,fitness);

    % Proses Cross over
    offspring=CrossOver(0.9, individu, 0);

    % Proses Mutasi
    offspring=Mutation(0.2, offspring, 2, minval, maxval, 5);

    % Proses elitism
    fitnessinduk=Fitness_Centroids(individu,data,totalcluster,dimensi);
    fitnessanak=Fitness_Centroids(offspring,data,totalcluster,dimensi);
    individu=Elitism(individu,fitnessinduk,offspring,fitnessanak);

    centroid=reshape(individu(1,:),totalcluster,dimensi);
    Draw2D(data,centroid);
    minJ=1/Fitness_Centroids(individu(1,:),data,totalcluster,dimensi)
    pause
end %end for

centroid=reshape(individu(1,:),totalcluster,dimensi);
[clusters,endcentroid]=KmeansClustering(data,totalcluster,centroid);
Draw2D(data,endcentroid,clusters);


