% Contoh program kasus Word Matching
%
% 2006 (c) Machine Learning Team
% Politeknik Elektronika Negeri Surabaya - ITS
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

function ga_wordmatching()
clear; clc;

% Pemodelan kasus
target=['G','E','N','E','T','I','K','A'];
stringtarget=target-64;
jumlahkromosom=length(target);
jumlahgenperkromosom=1;
jumlahgen=jumlahgenperkromosom*jumlahkromosom;
jumlahindividu=10;

%Mencari nilai min dan max pada setiap gen
minval=[]; maxval=[];
for i=1:jumlahgen
    minval(i)=1;
    maxval(i)=26;
end

% Populasi awal
individu=PopulasiAwal_WordMatching(jumlahindividu, jumlahgen);

match=0; generasi=1;
while (match==0)
    % Hitung nilai fitness
    fitness=Fitness_WordMatching(individu, stringtarget);

    % Seleksi dengan roulette
    individu=Selection(individu,fitness);

    % Proses Cross over
    anak=CrossOver(0.9, individu, 0);

    % Proses Mutasi
    anak=Mutation(0.2, anak, 2, minval, maxval, 1);

    % Proses elitism
    nilaifitnessinduk=Fitness_WordMatching(individu, stringtarget);
    nilaifitnessanak=Fitness_WordMatching(anak, stringtarget);
    individu=Elitism(individu, nilaifitnessinduk, anak, nilaifitnessanak);
    hasil=char(individu(1,:)+64)
    generasi=generasi+1;
    if (hasil==target) match=1; end
    
end

fprintf('Match pada generasi ke %d\n\n',generasi-1)
