%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% Function name : getJ
% Input : - Points -> clustering data
%         - Centroids -> centroids of clustering result
% Output : J -> objective function J
% 
% Description : to get minimum total distance between each data to its centroid
%
% 2004 (C) Ali Ridho Barakbah (ridho@eepis-its.edu)
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


function J=getJ(Points,Centroids)

totalpoint=size(Points,1);
totalcluster=size(Centroids,1);
mindis=[];
for i=1:totalpoint
    dis=[];
    for j=1:totalcluster
        d=Points(i,:)-Centroids(j,:);
        dis(j)=sqrt(d*d');
    end
    mindis(i)=min(dis);
end
J=sum(mindis);